$(document).ready(function () {
    /* 20221011 add メニューが一瞬表示される対応 ここから */
    // 特定のテーマでメニューの開閉機能をセット
  var
    $window = $(window),
    $body = $('body'),
    $header = $('#page-header');
  if ($body.hasClass('doc-enable-menu-slide')) {

      // XSサイズであればメニューを閉じる
      if ($window.width() <= 1000) {
        $body.addClass('status-menu-closed');
      }

  }
	var pathname= location.pathname;
  if( pathname.indexOf("index_book.htm") == -1){ 
    var a_obj = $('a[href^="#"]');
    for(var index = 0; index < $(a_obj).length ; index++){
	    var href= $(a_obj[index]).attr("href");
	    if(href == "#" ){
		  } else {
		    var events = $._data($(a_obj[index]).get(0), "events");
           if( events == null || events === undefined || events.click[0] == null ||  events.click[0].handler == null ||  events.click[0].handler === undefined){
            continue;
			} 
	      var originalHandler = events.click[0].handler;
	      // 元のsubmitイベントを外す
	      //$('form[name="loginform"]').off('submit', originalHandler);
		    $(a_obj[index]).off("click");
	      // submitイベントに、別のハンドラを設定し、引数として元のハンドラを渡す
		    $(a_obj[index]).on('click', {next: originalHandler}, function (e) {
	        var href= $(this).attr("href");
	        /* 20220721 add  242 No.215の不具合対応 ここから */
	        history.pushState(null, null, null);
	        /* 20220721 add  242 No.215の不具合対応 ここまで */
	        if (href != "#") {
				    href = selectorEscape(href);
	          var target = $(href);
	          if (target.length) {
						/* 20221208 change No.313の対応 ここから */
	            var speed = 0;
	            var position = target.position().top ;
	            if ($('div.cnt_max').length) {
							  $("html, body").animate({scrollTop:position}, speed, "swing");
							  e.stopImmediatePropagation();
							  e.stopPropagation();
							  return false;
						  }
						/* 20221208 change No.313の対応 ここまで */
	          }
	        } else {
				  //e.data.next();
	        }
	      });
			}
		}
	} else {
    /* 20221011 add メニューが一瞬表示される対応 ここまで */
    $('a[href^="#"]').on('click', {next: originalHandler}, function (e) {
      var href= $(this).attr("href");
      /* 20220721 add  242 No.215の不具合対応 ここから */
      history.pushState(null, null, null);
      /* 20220721 add  242 No.215の不具合対応 ここまで */
      if (href != "#") {
        href = selectorEscape(href);
        var target = $(href);
        if (target.length) {
          /* 20221208 change No.313の対応 ここから */
          var speed = 0;
          var position = target.position().top ;
          $("html, body").animate({scrollTop:position}, speed, "swing");
          e.stopImmediatePropagation();
          e.stopPropagation();
          return false;
        }
      /* 20221208 change No.313の対応 ここまで */    
      } else {
        //e.data.next();
      }
    });
	}
	function selectorEscape(val){
	    return val.replace(/[ !"$%&'()*+,.\/:;<=>?@\[\\\]^`{|}~]/g, '\\$&');
	}
    /* 20220726 add 235 No.208 実機でスクロールするとリサイズイベントが発生するので回避 ここから */
    if($(window).width() <= 769) {
        $('#select-page-tree-search').css('display', 'none');
    }
    
});

//
//
// ===== 共通スクリプト =====
//
//


//
// === 初期実行 ===
//

$(function() {
'use strict';


  //
  // === 共通 ===
  //

  var
    $window = $(window),
    $body = $('body'),
    $header = $('#page-header');



  //
  // --- メニューをセット ---
  //

  var setMenuList = function($menu) {

    var
      $menuList = $menu.children('ul'),
      classGroup = 'group',
      classGroupExpanded = 'expanded',
      classActive = 'active',
      slideSpeed = 'fast',
      // location.filepathの場合、file:スキーム時にフルパスとなるためhrefを利用しています
      filename = window.location.href.match(".+/(.+?)([\?#;].*)?$")[1];

    // --- グループの開閉 ---
    //$menuList
    //  .children('li')
    //  .has('ul')
    //  .addClass(classGroup);

    $menuList.find('li').each(function(){
      var current = $(this);
      if(current.children('ul').size()>0){
       current.addClass(classGroup);
      }
    });

    // --- 現在地をセットし、第2階層の場合は開く ---
    $menuList
      .find('a[href=\"' + filename +  '\"]')
      .parent('li')
      .addClass(classActive)
      .parents('.' + classGroup)
      .addClass(classGroupExpanded)
      .children('ul')
      .show();

    // --- グループの親が現在地の場合も開く ---
    $menuList
      .find('.group.active')
      .addClass(classGroupExpanded)
      .children()
      .show();

    // --- アイコンをクリック ---
    $menuList
      .find('.' + classGroup + ' > .icon')
      .click(function(e) {
        var $this = $(this);
        var $parent = $this.parents('li').first();
        var $childList = $parent.children('ul').first();

        if ($parent.hasClass(classGroupExpanded)) {
          $childList.slideUp(slideSpeed,function(){
            checkMenuStatus();
          });
          $parent.removeClass(classGroupExpanded,function(){
            checkMenuStatus();
          });
        } else {
          $childList.slideDown(slideSpeed,function(){
            checkMenuStatus();
          });
          $parent.addClass(classGroupExpanded);
        }
              // 開きありの対応
      $("span.icon.bullet.notchildren").each(function(i, elem) {

		var data = $(elem).parent("li");

     	$(data).css({'cssText': 'display: none !important;'});
		var targetSpan = $(elem).parent("li").parent("ul").prev().prev();
        $(targetSpan).removeClass("icon");

	  });
      return false;
    });


    //開閉状態をチェック
    var checkMenuStatus = function(){
      const classStatusExpanded = 'is-expanded';
      const classStatusAllExpanded = 'is-allexpanded';
      const $expanded =  $('.nav-menu-list').find('.' + classGroupExpanded ) ;
      if(  $expanded.length > 0 ){
        $('body').addClass( classStatusExpanded );
      }else{
        $('body').removeClass( classStatusExpanded );
      }
      if( $('.nav-menu-list').find("ul:hidden").length == 0 ){
        $('body').addClass( classStatusAllExpanded );
      }else{
        $('body').removeClass( classStatusAllExpanded );
      }
    }
    checkMenuStatus();

    const $topremoveclass =  $("#wiki-content .tab-index-page").find('.mt8');
    if(  $topremoveclass.length > 0 ){
      $("#wiki-content .tab-index-page table").removeClass('mt8 mb8');
    }
    
  };

  //
  // --- スクロールバーをセット ---
  //

  var setCustomScrollbar = function($customScroll) {

    if ($.fn.mCustomScrollbar) {

      var themeName = $customScroll.attr('data-scroll-theme');

      themeName = themeName ? themeName : 'light';

      $customScroll
        .mCustomScrollbar({
          axis: 'y',
          theme: themeName,
          autoHideScrollbar: false,
          set_height:( $(window).height() - parseInt($('#page-menu .nav-menu-container').css('margin-top')) - $('#page-header').outerHeight()) - 12 + "px",
          advanced:{
            //updateOnContentResize: true
          },
        });
    };
    function includeJa(text) {
        try {
            var data = decodeURI(text);
            let gmi = 'gmi';
            let regeIncludeHiragana = '^(?=.*[\u3041-\u3096]).*$';
            let regeIncludeKatakana = '^(?=.*[\u30A1-\u30FA]).*$';
            let regeIncludeKanji = '^(?=.*[\u4E00-\u9FFF]).*$';
            let regeHiragana = new RegExp(regeIncludeHiragana, gmi);
            let regeKatakana = new RegExp(regeIncludeKatakana, gmi);
            let regeKanji = new RegExp(regeIncludeKanji, gmi);

            let includeJa = false;
            if (regeHiragana.test(data))
                includeJa = true;
            if (regeKatakana.test(data))
                includeJa = true;
            if (regeKanji.test(data))
                includeJa = true;

            return includeJa;
        } catch (error) {
            alert(error);
        }
    }

  //
  // --- スムーススクロール ---
  //

  if ($.fn.smoothScroll) {

    var scrollOffset = $('#page-header').height() + 20;  // 20はヘッダー下部との隙間サイズです

    // --- ページ内 ---
	//console.log("location.hash : " + location.hash);
    $('#page-content a[href^="#"]')
      .smoothScroll({
        offset: -scrollOffset
      });


    // --- ページが開いた時 ---

    if (location.hash) {
      var locationHash = decodeURI(location.hash);
		function selectorEscape(val){
		    return val.replace(/[ !"$%&'()*+,.\/:;<=>?@\[\\\]^`{|}~]/g, '\\$&');
		}
		var href = selectorEscape(locationHash);
       var target = $(href);
       if (target.length) {
			/* 20221208 change No.313の対応 ここから */
            var speed = 0;
            var position = target.position().top ;
            if ($('div.cnt_max').length) {
				$("html, body").animate({scrollTop:position}, speed, "swing");
                return false;
            }
			/* 20221208 change No.313の対応 ここまで */
  		}
    //}

  	}
  }

  };

  //
  //
  // === ウィンドウイベント ===
  //
  //

  var
    classScrollDown = 'status-scroll-down',
    classScrollUp = 'status-scroll-up';


  //
  // --- スクロール位置でクラスを変更（トップから一定量スクロールダウン） ---
  //

  if ($body.hasClass('doc-enable-scroll-down')) {

    var
      scrollTopThreshold = $header.height();

    $window
      .scroll(function() {

        var currentPos = $(this).scrollTop();

        if (currentPos > scrollTopThreshold) {
          $body.addClass(classScrollDown);
        } else {
          $body.removeClass(classScrollDown);
        }

      });

  }


  //
  // --- スクロール位置でクラスを変更（スクロールアップ／ダウン） ---
  //

  if ($body.hasClass('doc-enable-scroll-updown')) {

    var
      scrollStartPos = 0,
      scrollThreshold = 50,
      isScrollDown = false;

    $window
      .scroll(function() {

        var currentPos = $(this).scrollTop();

        if (Math.abs(scrollStartPos - currentPos) > scrollThreshold) {

          if (currentPos > scrollStartPos) {

            // 下にスクロール中
            if (!isScrollDown) {
              $body
                .removeClass(classScrollUp)
                .addClass(classScrollDown);
            }
            isScrollDown = true;

          } else {

            // 上にスクロール中
            if (isScrollDown) {
              $body
                .removeClass(classScrollDown)
                .addClass(classScrollUp);
            }
            isScrollDown = false;

          }

          scrollStartPos = currentPos;

        }

      });

  }



  //
  // === ピンチイン／アウト対応 ===
  //

  var
    classPinchOut = 'status-pinch-out';

  $body
    .on('gesturechange', function(event) {
      var
        orgEvent = event.originalEvent,
        scale = Math.round(orgEvent.scale * 100) / 100;

      if (scale > 1) {
        $body.addClass(classPinchOut);
      } else {
        $body.removeClass(classPinchOut);
      }

    });



  //
  //
  // === ファイルの読み込み ===
  //
  //

  //
  // --- メニューを読み込み ---
  //
  $(window).load(function (){

	function _resizeTableAtTopPage(){
		const $table = $('.tab-index-page table');
		var num = 0;
		var maxHeight = 0;
		$table.each(function(){
			var tableHeight = $(this).height();
			if(tableHeight > maxHeight){
				maxHeight = tableHeight;
			}
			num ++;
		});
		if(num = $table.length){
			$table.css('height',maxHeight);
		}
	}

		_resizeTableAtTopPage();
    //トップページの画像以外が対象
    //console.log("aaaaa");
    $('main img').each(function(i, elem) {
　　　var chID = $(elem).attr("id");
      if( chID != "top_page_image"){
	      if( $(elem).parents('p.smallTableTrigger').length == 0 &&
            $(elem).parent('a').length == 0){
	           var elem_src = $(elem).attr("src");
	           //console.log("elem_src : "+ elem_src);
	           $(elem).wrap('<a href="' + elem_src + '" rel="lightbox"></a>');
	         }
			}
    });
    


      // 特定のテーマでメニューの開閉機能をセット
      if ($body.hasClass('doc-enable-menu-slide')) {

        // XSサイズであればメニューを閉じる
        if ($window.width() <= 1000) {
          $body.addClass('status-menu-closed');
        }

        setMenuList($('.wiki-toc'));

      }

      // [Stone] の場合メニューを半分にする
      if ($body.hasClass('doc-theme-stone')) {
        var
          $list = $('.wiki-toc').children('ul').children('li'),
          listCount = $list.length;
         $list
          .eq(Math.ceil(listCount / 2))
          .prevAll()
          .addClass('first-column');
      }

      // カスタムスクロールをセット
      setCustomScrollbar($('.custom-scroll-bar'));

      //画像の高さ指定を幅指定に変換する
      $('div#wiki-content img[height], div.accordion_sct img[height]').each(function(){
          var height_attr = $(this).attr('height');

          var img = new Image();
          img.src = $(this).attr('src');
          var img_height = img.height;
          var img_width = img.width;

          $(this).css('width', (height_attr * img_width) / img_height);
          $(this).removeAttr('height');
      });

      // 開きありの対応
      $("span.icon.bullet.notchildren").each(function(i, elem) {

		var data = $(elem).parent("li");

     	$(data).css({'cssText': 'display: none !important;'});
        var targetSpan = $(elem).parent("li").parent("ul").prev().prev();
        $(targetSpan).removeClass("icon");
      });

	/*const url = $(location).attr('href'),
	// headerの高さを取得してそれに30px追加した値をheaderHeightに代入
	headerHeight = $('header').outerHeight() + 30;

	// urlに「#」が含まれていれば
	if(url.indexOf("#") != -1){
		// urlを#で分割して配列に格納
		const anchor = url.split("#"),
		// 分割した最後の文字列（#◯◯の部分）をtargetに代入
		target = $('#' + anchor[anchor.length - 1]),
		// リンク先の位置からheaderHeightの高さを引いた値をpositionに代入
		position = Math.floor(target.offset().top) - headerHeight;
		// positionの位置に移動
		$("html, body").animate({scrollTop:position}, 500);
	}*/

  });

  /* 164 No.140　本体操作部表示のとき言語プルダウンが出ない トップだけ表示に変更 ここから */
  var pathname = location.pathname;
	if(pathname.indexOf("index_book.htm") >= 0 ){
    var html_lang = document.documentElement.lang;
	  if( navigator.userAgent.indexOf("ricoh_mfpapnl") >= 0 ) {
	    // console.log(navigator.userAgent.indexOf("ricoh_mfpapnl"));
	    $(".btn-change-font").css('display','none');
       var LANG_LIST_length = Object.keys(LANG_LIST).length;
      if( LANG_LIST_length > 0){
		    var buf = new Array();
		  	buf.push('<div class="selectLanguage">');
		  	buf.push('<form name="frmLanguage">');
		  	buf.push('<select class="languagePulldown" name="opLanguage" id="jump">');

	      for(var hash_key in LANG_LIST){
	         if(html_lang.toUpperCase() == hash_key.toUpperCase()){
	           buf.push('<option value="#" selected>'+ LANG_LIST[hash_key] + '</option>');
	         } else {
	           buf.push('<option value="../../../' + hash_key + '/booklist/int/index_book.htm">' + LANG_LIST[hash_key] + '</option>');
	         }
		  	   
		  	  //buf.push('<option value="../../../en/booklist/int/index_book.htm">English</option>');
		  	  //buf.push('<option value="../../../de/booklist/int/index_book.htm">Deutsch</option>');
		  	  //buf.push('<option value="../../../fr/booklist/int/index_book.htm">Fran&#231;ais</option>');
			}
		  	buf.push('</select></form></div>');
		  	$("div#header-right").prepend(buf.join(''));
		  	if (document.getElementById("jump") != null) {
		  		document.getElementById("jump").onchange = function(){
		  			jump();
		  		}
		  	}
	      $('div.selectLanguage').css('padding-right','80px');
       } else {
			$('#page-search form').addClass('no-data');
       }
	  }
  }
  /* 164 No.140　本体操作部表示のとき言語プルダウンが出ない トップだけ表示に変更 ここまで */

  //20220826　ricoh_mfpapnlの場合は、メニューをスマホに合わせる　修正追加　ここから　田中
  if( navigator.userAgent.indexOf("ricoh_mfpapnl") >= 0 ) {
    $('#page-menu').addClass('is_mfpapnl');
    $('nav.nav-sequence').addClass('is_nav_mfpapnl');/* 20221117 アラビア語機種対応 */
    /* 20221205 操作部時はポップアップなし */
    $('#page-menu div#nav-menu-header a.btn-view-switch span.description').css('display','none');
    var platform = navigator.platform;
    /* 20230117 操作部のAndroid 6ベースの対応 */
    if(platform.indexOf("Linux armv7l") >= 0 ){
		//console.log("Linux armv7l");
       $('div.to-page-top').css('padding-top','2px');
    }
  }
  //20220826　ricoh_mfpapnlの場合は、メニューをスマホに合わせる　修正追加　ここまで　田中
  
  if($('nav.nav-sequence a[href="index_book.htm"]').length > 0){
      var indexdata = $('nav.nav-sequence a[href="index_book.htm"]').children();
			$(indexdata).text(CONST_TEXT.breadcrumbTop);
	}
  if($('nav.nav-sequence a[href="index_book.htm"]').length > 0){
		var index_book_page = $('nav.nav-sequence a[href="index_book.htm"] span').text();
    $('footer#page-footer div.bottom-page-link a[href="index_book.htm"] span').text(index_book_page);
	}
  //
  //
  // === アニメーションの準備完了 ===
  //
  //

  // --- アニメーションの準備がｋできたらクラスを追加 ---
  setTimeout(function() {
    $body.addClass('animation-ready');
  }, 100);

  /* 164 No.140　本体操作部表示のとき言語プルダウンが出ない トップだけ表示に変更 ここから */
	function jump(){
	    var selectNo = document.frmLanguage.opLanguage.selectedIndex;
	    var url = document.frmLanguage.opLanguage.options[selectNo].value;
	    location.href = url;
	}
  /* 164 No.140　本体操作部表示のとき言語プルダウンが出ない トップだけ表示に変更 ここまで */

});

// --- eof ---
